#!/usr/bin/gawk -f
#
# fraglets0.17/bin/f2g.awk
#
# conversion from a fraglet program file to genome representation;
# a genome is a concatenation of multiple fraglets in a single line,
# for easier crossover and mutation.
#
# Copyright (C) 2002-2005 Christian Tschudin <tschudin@docs.uu.se>
#
# This file is distributed under the terms of the GNU general Public
# License (GPL), see the file COPYING
#
# History:
# 20050208: updated by author and lidia.yamamoto@unibas.ch, fraglets v0.17
# 20030706: updated by christian.tschudin@unibas.ch, fraglets v0.16
# 200203??: created by tschudin@docs.uu.se


BEGIN {
	i = 1;
}

/^f/ {
	f[i] = substr($0, 3);
	gsub(" ", "", f[i]);
	i++;
}

/^m/ {
  f[i++] = $0;
}


/^g/ {
  print $0;
}

function f2g() {
  #asort(f); (alphabetic sorting)
	if (i == 1) {
	  exit;
	}
	printf "g ";
	i = 1;
	while (i in f) {
		printf "/";
		e = f[i];
		ib = index(e, "]");
		mult = substr(e, ib+1, ib+1);
		if (mult == "") {
		  printf "%s1", e;
		} else {
		  printf "%s", e;
		}
		i++;
	}
	print "/";
	i = 1;
}

/^e/ {
  f2g();
}


END {
  f2g();
  print "\n";
}
